<?php
namespace EMS\PortalFuncionario\Geral\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;

use EMS\PortalFuncionario\Geral\Services\GeralService;

class GeralController {
    /** @var GeralService */
    protected $geralService;

    public function __construct(EntityManager $entityManager, GeralService $geralService) {
        $this->entityManager = $entityManager;
        $this->geralService  = $geralService;
    }

    public function getAniversariantes(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $params = $request->getParameters();

            $nrOrg = (int) $params['NRORG'];
            $data = $params['DATA'] ?? null;

            $aniversariantes = $this->geralService->getAniversariantes(
                $nrOrg,
                $data
            );

            $response->addDataSet(new DataSet('data', $aniversariantes));
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }

}