<?php
namespace EMS\PortalFuncionario\Geral\Services;

use Zeedhi\Framework\Controller\Crud;
use Doctrine\ORM\EntityManager;

use EMS\PortalFuncionario\Util\DateUtil;

use EMS\PortalFuncionario\Geral\Repository\OperadorRepository;

class OperadorService extends Crud {

    public function __construct(EntityManager $entityManager, OperadorRepository $operadorRepository) {
        $this->entityManager        = $entityManager;
        $this->operadorRepository   = $operadorRepository;
    }

    public function getDadosOperador(string $cdoperador) {
        try {
            $dadosOperador = $this->operadorRepository->getDadosOperador($cdoperador);
            if (empty($dadosOperador) || empty($dadosOperador[0])) {
                throw new \Exception('Operador não encontrado');
            }
            return $dadosOperador[0];
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function validaLogin(string $nrvinculom, string $nrorg) {
        try {
            $loginValido = !empty($this->operadorRepository->validaLogin(
                $nrvinculom,
                $nrorg
            ));
            return $loginValido;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function validaLoginOperador(string $cdoperador) {
        try {
            $dadosOperador = $this->getDadosOperador($cdoperador);

            $loginValido = !empty($dadosOperador);
            $dadosOperador['LOGINVALIDO'] = $loginValido;

            return $dadosOperador;
        } catch (\Exception $e) {
            throw $e;
        }
    }

}