/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRODSERVTCON                                             */
/* Tabela : PRODSERVTCON                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 27/06/2007 - FELIPE HENRIQUE                                               */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
             o.name = 'DTULTATU_PRODSERVTCON'and
             type = 'TR'                     and
             u.uid = o.uid                   and
             u.name = USER)
   DROP TRIGGER DTULTATU_PRODSERVTCON
GO

CREATE TRIGGER DTULTATU_PRODSERVTCON
ON PRODSERVTCON
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'PRODSERVTCON', CDFILIAL, 'CDFILIAL=' + CDFILIAL + ';' +
                                                                'CDCAIXA=' + CDCAIXA + ';' +
                                                                'CDSERVFILI=' + CDSERVFILI  + ';' +
                                                                'CDTIPOCONS=' + CDTIPOCONS + ';' +
                                                                'CDPRODUTO=' + CDPRODUTO + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED);

   END
   ELSE BEGIN
      UPDATE PRODSERVTCON
      SET DTULTATUPRSTCON = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(PRODSERVTCON.CDFILIAL,0)    = ISNULL(INSERTED.CDFILIAL,0))AND
            (ISNULL(PRODSERVTCON.CDCAIXA,0)     = ISNULL(INSERTED.CDCAIXA,0))AND
            (ISNULL(PRODSERVTCON.CDSERVFILI,0)  = ISNULL(INSERTED.CDSERVFILI,0))AND
            (ISNULL(PRODSERVTCON.CDTIPOCONS,0)  = ISNULL(INSERTED.CDTIPOCONS,0))AND
            (ISNULL(PRODSERVTCON.CDPRODUTO,0)   = ISNULL(INSERTED.CDPRODUTO,0));
   END;
END;
GO

UPDATE PRODSERVTCON SET DTULTATUPRSTCON = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUPRSTCON IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUPRSTCON' and
            type = 'D')
   ALTER TABLE PRODSERVTCON DROP CONSTRAINT DEFAULT_DTULTATUPRSTCON
GO

ALTER TABLE PRODSERVTCON ADD CONSTRAINT DEFAULT_DTULTATUPRSTCON
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUPRSTCON
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PRODSERVTCON','4.11.194';
GO

